// Header file for DRAW_shell
//
// Coded August 10, 2005 by L.W. Finger, M. Kroeker, and B. Toby
//
// Part of the DRAWxtl system

#ifndef draw_shell_h
#define draw_shell_h
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#ifdef WIN32
  #include <direct.h>
#else
  #include <unistd.h>
  #include <string.h>
  #include <FL/Fl_File_Chooser.H>
#endif
#if !defined(WIN32) && !defined(__APPLE__)
  #include <X11/xpm.h>
  Pixmap icon;
#endif
#include <FL/x.H>
#include <FL/Fl.H>
#include <FL/Fl_Double_Window.H>
#include <FL/Fl_Window.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Multiline_Output.H>
#include <FL/Fl_Menu_Button.H>
#include <FL/Fl_Text_Display.H>
#include <FL/Fl_Text_Editor.H>
#include <FL/Fl_Text_Buffer.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/fl_ask.H>
#include <FL/Fl_Input.H>

#define IDI_ICON1  101

// Global widget pointers
  
Fl_Output * Command_Line_Options;
Fl_Output * Current_Directory;
Fl_Output * Current_Structure_File;
Fl_Input  * drawxtl_options;
Fl_Window * errorbox = NULL;
Fl_Text_Buffer * helpbuf = NULL;
Fl_Window * helpwindow = NULL;
Fl_Window * helpwindow1 = NULL;
Fl_Window * helpwindow2 = NULL;
Fl_Window * helpwindow3 = NULL;
Fl_Window * helpwindow4 = NULL;
Fl_Window * listwindow1 = NULL;
Fl_Window * listwindow2 = NULL;
Fl_Window * optionswindow = NULL;
Fl_Input  * pov_options;
Fl_Output * POV_Options;
Fl_Text_Buffer * textbuf = NULL;
Fl_Window * textwindow = NULL;

// Global variables

int  autolabel;
char Cur_Dir[256];
char Cur_File[256];
char Cur_Listing[256];
char Cur_Root[256];
char DefaultFinish[256];
char DRAWxtl_Option[256];
char DRAWxtl_Path[256];
int  Edit_changed;
int  Edit_loading;
char Edit_title[256];
char FileViewName[256];
char GUIExePath[256];
char LoadOnStartup[256];
char POV_Include[256];
char POV_Option[256];
char POV_Path[256];
void trim_string( char *, int);
char VRML_Path[256];
char VRML_Use_Browser[256];

// Prototypes for routines

void About_Help_cb(void);
void Color_Help_cb(void);
void Command_Help_cb(void);
void Configure_DRAWxtl_cb(void);
void Configure_POV_cb(void);
void Configure_VRML_cb(void);
void Edit_Changed_cb(int, int, int,int, const char*, void*);
void Edit_Data_cb(void);
void Edit_STR_Close_cb(void);
void Edit_STR_Save_cb(Fl_Button *,int * action);
void Error_Box(char *);
void Error_Box_cb(Fl_Widget *, void *);   
void Exit_cb(void);
void Graphics_Help_cb(void);
void Input_Help_cb(void);
void LoadConfig(void);
Fl_Double_Window * make_window();
void Options_Close_cb(void);
void Options_Save_cb(void);
void Run_DRAWxtl_cb(void);
void SelectDataFile_cb(void);
void Set_Options_cb(void);
void View_Help_Close_cb(Fl_Window *, int * arg);
void View_List_Close_cb(Fl_Window *, int * arg);
void View_Listing_cb(void);
void View_POV_cb(void);
void View_VRML_cb(void);
void WriteConfig(void);
#endif
