#include "drawxtl.h"
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>
#include "draw_ext.h"
#ifdef OPENGL

void draw_cursor (void);				 /* display openGL cursor */
void move_cursor (int, float inc_amt);      /* move the cursor */

extern void add_vert_nc (float *);
extern int gl_height;

void draw_cursor (void) {

  int i,j;
  float vert[3];

  if (!cur_show) return;

  nvert = 0;				 /* initialize vertex list */
  for (i = 0; i <= 2; ++i) {
    for (j = 0; j <= 2; ++j)
      vert[j] = cur_cen[j];
    vert[i] = cur_cen[i] - 0.5f / drvui->lat_con[i];
    add_vert_nc (vert);
    vert[i] = cur_cen[i] + 0.5f / drvui->lat_con[i];
    add_vert_nc (vert);
  }

  glPushMatrix ();
  glColor3f (1.0, 0.0, 0.0);

  glBegin (GL_LINES);
  glVertex3f (s_vert[0], s_vert[1], s_vert[2]);
  glVertex3f (s_vert[3], s_vert[4], s_vert[5]);
  glEnd ();

  glBegin (GL_LINES);
  glVertex3f (s_vert[6], s_vert[7], s_vert[8]);
  glVertex3f (s_vert[9], s_vert[10], s_vert[11]);
  glEnd ();

  glBegin (GL_LINES);
  glVertex3f (s_vert[12], s_vert[13], s_vert[14]);
  glVertex3f (s_vert[15], s_vert[16], s_vert[17]);
  glEnd ();

  glPopMatrix ();
}

void move_cursor (int axis, float inc_amt) 
{
  if (!cur_show) return;
    cur_cen[axis] += inc_amt * cur_step / drvui->lat_con[axis];
/*     printf ("  pos: %f,%f,%f\n", cur_cen[0], cur_cen[1], cur_cen[2]); */
    draw_cursor();
    glutPostRedisplay ();
}

int find_proj_atom(int x, int y)
{
    int j;
    double distance = 1.0e15,d;
    int closest=0;
    GLdouble winX, winY, winZ;
    int saved_nvert = nvert;
    int sy = viewport[3] - y;

   for (j = 0; j < natom; ++j) {           // get all atoms in display box
      find_all_in_box (j);
    }
    for (j=saved_nvert;j<nvert;j++) {       // loop through all atoms
        gluProject(s_vert[3*j], s_vert[3*j + 1], s_vert[3*j + 2],
            modelMatrix, projMatrix, viewport,
            &winX, &winY, &winZ);
        d = (float)(x - winX) * (float) (x - winX) +
            (float) (sy - winY)  * (float)(sy - winY);
        if (d<distance)	{                    // find closest atom (in projection
            distance=d;
            closest=j;
        }
    }
    cur_cen[0]=o_vert[3*closest];            // set cursor to atom coordinates
    cur_cen[1]=o_vert[3*closest+1];
    cur_cen[2]=o_vert[3*closest+2];
    nvert = saved_nvert;
    return closest;
}

int find_atom(void)
{
    int i,j;
    double distance = 1000.0,d;
    int closest=0;

    nvert=0;
    for (i=0;i<natom;i++) 
      find_all_in_box(i);

    for (j=0;j<nvert;j++) {
      d= (o_vert[3*j]-cur_cen[0])*(o_vert[3*j]-cur_cen[0])
          +(o_vert[3*j+1]-cur_cen[1])*(o_vert[3*j+1]-cur_cen[1])
          +(o_vert[3*j+2]-cur_cen[2])*(o_vert[3*j+2]-cur_cen[2]);
      if (d<distance)	{
        distance=d;
        closest=j;
      }
    }
    cur_cen[0]=o_vert[3*closest];
    cur_cen[1]=o_vert[3*closest+1];
    cur_cen[2]=o_vert[3*closest+2];
    return closest;
}

void Update_Cursor_List(float cen[3], int i)
{
    float dot;
    char atnum[20];
    int n;
    char cur_name_t[256];

    n = drvui->orig_atom_no[i];
    strcpy(cur_name_t,"");
    if (cur_atom[3] > 0) {
        cur_atom[0]=cur_atom[1];
        cur_atom[1]=cur_atom[2];
        cur_atom[2]=cur_atom[3];
        strcpy(cur_name[0],cur_name[1]);
        strcpy(cur_name[1],cur_name[2]);
        strcpy(cur_name[2],cur_name[3]);
    }
    if (cur_atom[1] > 0)
        dist12 = dist(cur_atom[0],cur_atom[1]);
    if (cur_atom[2] > 0) {
        dist23=dist(cur_atom[1],cur_atom[2]);
        if (dist12==0.0f || dist23==0.0f || cur_atom[2]==cur_atom[0]) {
            ang123=0.0f;
        } else {
            float temp;
            dot=dot0_3d (
            s_vert[3*cur_atom[1]],s_vert[3*cur_atom[1]+1],s_vert[3*cur_atom[1]+2],
            s_vert[3*cur_atom[0]],s_vert[3*cur_atom[0]+1],s_vert[3*cur_atom[0]+2],
            s_vert[3*cur_atom[2]],s_vert[3*cur_atom[2]+1],s_vert[3*cur_atom[2]+2]);
            temp = dot/(dist12 * dist23);
            if (temp > 1.0f) temp = 1.0f;
            if (temp < -1.0f) temp = -1.0f;
            ang123=(float)(acos(temp)*RAD);
        }
    }
    if (n < 0) {
        strcat(cur_name_t,"rho");
    } else {
        strcat(cur_name_t,drvui->atom_l[n]);
        trim_string(cur_name_t,5);
        sprintf(atnum,"%d",drvui->sv_atom_n[n]);
        strcat(cur_name_t,atnum);
    }
    if (cur_atom[0] <=0) { 
        cur_atom[0] =i;
        strcpy(cur_name[0],cur_name_t);
    } else if (cur_atom[1] <=0) { 
        cur_atom[1] = i;
        strcpy(cur_name[1],cur_name_t);
        dist12=dist(cur_atom[0],cur_atom[1]);
    } else if (cur_atom[2] <= 0) {
        cur_atom[2] = i;
        strcpy(cur_name[2],cur_name_t);
        dist12=dist(cur_atom[0],cur_atom[1]);
        dist23=dist(cur_atom[1],cur_atom[2]);
        if (dist12==0.0f || dist23==0.0f || cur_atom[2]==cur_atom[0]) {
            ang123=0.0f;
        } else {
            float temp;
            dot=dot0_3d (
            s_vert[3*cur_atom[1]],s_vert[3*cur_atom[1]+1],s_vert[3*cur_atom[1]+2],
            s_vert[3*cur_atom[0]],s_vert[3*cur_atom[0]+1],s_vert[3*cur_atom[0]+2],
            s_vert[3*cur_atom[2]],s_vert[3*cur_atom[2]+1],s_vert[3*cur_atom[2]+2]);
            temp = dot/(dist12 * dist23);
            if (temp > 1.0f) temp = 1.0f;
            if (temp < -1.0f) temp = -1.0f;
            ang123=(float)(acos(temp)*RAD);
        }
    } else {
        float v1[3], v2[3], v0[3], p1[3], p2[3];
        int j;

        cur_atom[3] = i;
        strcpy(cur_name[3],cur_name_t);
        dist23 = dist(cur_atom[1],cur_atom[2]);
        dist34 = dist(cur_atom[2],i);
        for (j=0; j<3; j++) {
            v0[j] = s_vert[3*cur_atom[0] +j] - s_vert[3*cur_atom[1] +j];
            v1[j] = s_vert[3*cur_atom[1] +j] - s_vert[3*cur_atom[2] +j];
            v2[j] = s_vert[3*cur_atom[2] +j] - s_vert[3*cur_atom[3] +j];
        }
        if (dist23 == 0.0f || dist34 == 0.0f) 
          ang234 = 0.0f;
        else  {
          float temp;
          dot=vdot (v1,v2);
          temp = -dot/(dist23 * dist34);
          if (temp > 1.0f) temp = 1.0f;
          if (temp < -1.0f) temp = -1.0f;
          ang234=(float)(acos(temp)*RAD);
        }
        vcross(v0, v1, p1);                              // perpendicular to plane 1-2-3
        vcross(v2, v1, p2);                              // perpendicular to plane 2-3-4
        if (vlength(p1) < 0.1f || vlength(p2) < 0.1f) {
            torsion_ang = 0.0f;
            return;
        }
        torsion_ang = -vdot(p1,p2)/(vlength(p1) * vlength(p2));
        if (torsion_ang < -1.0f) torsion_ang = -1.0f;
        if (torsion_ang > 1.0f) torsion_ang = 1.0f;
        torsion_ang = (float)(acos(torsion_ang)*RAD);
        if (vdot(p1,v2) > 0.0f)                         // get the sign
            torsion_ang *= -1.0f;
    } 
}

int Maximize_rho(int Sense)
{
// find min/max in rho - Sense is -1 if min, +1 if max
    float rhomax = -1.0e15f;
    int i, j, k, l;
    float w0[3][3][3];
    int maxpt;
    float param[7];
    int map[3];

    if (! ReadFourMap)
        return (-1);
// extract 3x3x3 array of points around the current position
    for (i=0; i<7; i++)
        param[i] = 0.0f;
    map[0] = (int)((float)mapstep_a * cur_cen[0] + 0.5);
    map[1] = (int)((float)mapstep_b * cur_cen[1] + 0.5);
    map[2] = (int)((float)mapstep_c * cur_cen[2] + 0.5);
    while (1) {
      rhomax = -1.0e15f;
      maxpt = -1;
      for (i=0; i<3; i++) {
        for (j=0; j<3; j++) {
            for (k=0; k<3; k++) {
                l = (map[0] +i - 1) * mapstep_b * mapstep_c
                    + (map[1] + j - 1) * mapstep_c + map[2] + k - 1;
                w0[i][j][k] = (float) Sense * FourierPt[l];
                if (w0[i][j][k] > rhomax) {
                    rhomax = w0[i][j][k];
                    maxpt = (i * 100) + (j * 10) + k;
                }
            }
        }
      }
      if (maxpt == 111)
          break;                            // maximum in middle
      k = maxpt % 10;                       // shift maximum to middle
      j = maxpt/10 % 10;
      i = maxpt / 100;
      map[2] += k-1;
      map[1] += j-1;
      map[0] += i-1;
      i = 0;
      if (map[0] < 1) {
          map[0] = 1;
          i = 1;
      }
      if (map[1] < 1) {
          map[1] = 1;
          i = 1;
      }
      if (map[2] < 1) {
          map[2] = 1;
          i = 1;
      }
      if (map[0] > mapstep_a-1) {
          map[0] = mapstep_a-1;
          i = 1;
      }
      if (map[1] > mapstep_b-1) {
          map[1] = mapstep_b-1;
          i = 1;
      }
      if (map[2] > mapstep_c-1) {
          map[2] = mapstep_c-1;
          i = 1;
      }
      if (i) break;
      cur_cen[2] = map[2]/(float)mapstep_c;
      cur_cen[1] = map[1]/(float)mapstep_b;
      cur_cen[0] = map[0]/(float)mapstep_a;
    }
    param[3] = -w0[1][1][1] + (w0[0][1][1] + w0[2][1][1]) * 0.5f;
    param[4] = -w0[1][1][1] + (w0[1][0][1] + w0[1][2][1]) * 0.5f;
    param[5] = -w0[1][1][1] + (w0[1][1][0] + w0[1][1][2]) * 0.5f;
    if (param[3] != 0.0f)
        param[0] = (w0[0][1][1] - w0[2][1][1]) * 0.25f/param[3];
    if (param[4] != 0.0f)
        param[1] = (w0[1][0][1] - w0[1][2][1]) * 0.25f/param[4];
    if (param[5] != 0.0f)
        param[2] = (w0[1][1][0] - w0[1][1][2]) * 0.25f/param[5];
    param[6] = w0[1][1][1] - param[3] * param[0] * param[0]
              - param[4] * param[1] * param[1] - param[5] * param[2] * param[2];

    cur_cen[0] += param[0]/mapstep_a;
    cur_cen[1] += param[1]/mapstep_b;
    cur_cen[2] += param[2]/mapstep_c;
    i = 0;
    for (k=0; k<nvert; k++) {
        if(fabs(o_vert[3*k] - cur_cen[0]) + fabs(o_vert[3*k+1] - cur_cen[1])
            + fabs(o_vert[3*k+2] - cur_cen[2]) < 0.001) i = k;
    }
    if (i) return i;                     // position already in vertex list
    drvui->orig_atom_no[nvert] = -1;     // new position - add it
    for (k = 0; k < 3; k++) {
        o_vert[3 * nvert + k] = cur_cen[k];
        s_vert[3 * nvert + k] = 0.0f;
        for (l = 0; l < 3; l++) {         /* calculate cartesian coordinates */
          s_vert[3 * nvert + k] +=
               (float) drvui->b_mat[k][l] * (cur_cen[l] - origin[l]);
        }
    }
    vert_sym_no[nvert++] = 0;
    if (nvert > MAX_VERTS) {
        Error_Box("Too many vertices for dimensions - increase MAX_VERTS.");
        return (-1);
    }
    return (nvert-1);
}

#endif
