/* Header file to support Fourier map */

/* Structure for storing vectors */
typedef struct {
	float x, y, z;
} mpVector;

typedef struct {
  float x, y, z;    /* orthonormal coordinates */
  float val;        /* rho value */
} mp4Vector;

/* struct for storing triangle information - 3 vertices and 3 normal vectors for each vertex */
typedef struct {
	mpVector p[3];
	mpVector norm[3];
} TRIANGLE;

TRIANGLE * MC_c (int ncellsX, int ncellsY, int ncellsZ, 
		 float gradFactorX, float gradFactorY, float gradFactorZ,
		 float minValue, mp4Vector *points, int *numTriangles);

void MCfree_c (TRIANGLE * trianglePt); /* use this to free memory created in C++  MCfree_c (pTriangles);  */

void generate_map (float minValue, int Solid, char * Color);

float InterpolateMap (float x, float y, float z); /* Interpolate a Rho value */ 

int LookupMap(int ix, int iy, int iz); /* lookup a point in the Fourier map */

