#!/bin/sh
# do not delete the backslash here \
exec wish "$0" "$@"
# /usr/X11R6/bin/wish8.0
#############################################################################
# Visual Tcl v1.10 Project
#

#################################
# GLOBAL VARIABLES
#
global DRAWxtlPath; 
global EditName; 
global FileViewName; 
global Options; 
global POVOptions; 
global POVpath; 
global VRMLpath; 
global fileset; 
global widget; 
set widget(CurDir) {.main.ent20}
set widget(CurFile) {.main.ent21}
set widget(DRAWxtlPath) {.config.ent27}
set widget(EditName) {.config.ent36}
set widget(FileViewName) {.config.ent39}
set widget(NotReady) {.notready}
set widget(Options) {.main.ent17}
set widget(POVoptions) {.main.ent18}
set widget(POVpath) {.config.ent34}
set widget(VRMLpath) {.config.ent30}
set widget(about) {.about}
set widget(help) {.help}
set widget(main) {.main}
set widget(msg) {.top21}
set widget(rev,.about) {about}
set widget(rev,.help) {help}
set widget(rev,.config.ent27) {DRAWxtlPath}
set widget(rev,.config.ent30) {VRMLpath}
set widget(rev,.config.ent34) {POVpath}
set widget(rev,.config.ent36) {EditName}
set widget(rev,.config.ent39) {FileViewName}
set widget(rev,.main) {main}
set widget(rev,.main.ent17) {Options}
set widget(rev,.main.ent18) {POVoptions}
set widget(rev,.main.ent20) {CurDir}
set widget(rev,.main.ent21) {CurFile}
set widget(rev,.notready) {NotReady}
set widget(rev,.top21) {msg}

#################################
# USER DEFINED PROCEDURES
#
#################################

proc init {argc argv} {

}

init $argc $argv


proc CancelConfigure {} {
;# called when 'Cancel' button clicked
  Window destroy .config
}

proc FileBrowse1 {} {
  global DRAWxtlPath
  global widget
  global fileset
  set DRAWxtlPath [GetFile2]
  if {$DRAWxtlPath != "" } {
    $widget(DRAWxtlPath) delete 0 end
    $widget(DRAWxtlPath) insert 0 $DRAWxtlPath
  } else {
    set DRAWxtlPath [$widget(DRAWxtlPath) get]
  }
}

proc FileBrowse2 {} {
  global VRMLpath; 
  global widget
  global fileset
  set VRMLpath [GetFile2]
  $widget(VRMLpath) delete 0 end
  $widget(VRMLpath) insert 0 $VRMLpath
}

proc FileBrowse3 {} {
  global POVpath; 
  global widget
  global fileset
  set POVpath [GetFile2]
  $widget(POVpath) delete 0 end
  $widget(POVpath) insert 0 $POVpath
}

proc GetFile2 {} {
  set file []
  set types  {{{All Files} {*}}}
  set file [tk_getOpenFile  -filetypes $types]
  return $file
}

proc FileGet {} {
  global FileName
  global widget
  global fileset
  set FileName [GetFile]
  $widget(CurDir) delete 0 end
  $widget(CurDir) insert 0 [pwd]
  set nfile [file tail $FileName]
  if {$nfile != ""} {
    $widget(CurFile) delete 0 end
    $widget(CurFile) insert 0 $nfile
    set fileset 1
  }
}

proc GetFile {} {
  set file []
  set types  {{{DRAWxtl Files} {*.str}}
             {{All Files} {*.*}}}
  set file [tk_getOpenFile -defaultextension {str} -initialdir [pwd] -filetypes $types]
  catch {cd [file dirname $file]}
  return $file
}

proc Listing {} {
;# look at the listing file
  global widget
  global fileset
  global FileViewName
  global EditName
  global Platform
  set nfile [$widget(CurFile) get]
  if {$fileset != 0} {
    switch $Platform {
      "windows" {
          set cmd "$EditName [file rootname $nfile].out"
          eval exec $cmd
        }
      default {
          set cmd "$FileViewName [file rootname $nfile].out"
          forknewterm "Examine Listing" $cmd 0 0
        }
    }
  } else {
    Window show $widget(NotReady)
    focus -force $widget(NotReady)
  }
}

proc OKConfigure {} {
# entered when the 'OK' button in configuration screen is clicked
  global DRAWxtlPath
  global EditName
  global FileViewName
  global POVpath
  global VRMLpath
  global widget
  global autolabel
  global Autolabel
  global Options
# load variables from widgets 
  set DRAWxtlPath [$widget(DRAWxtlPath) get]
  set POVpath [$widget(POVpath) get]
  set VRMLpath [$widget(VRMLpath) get]
  set EditName [$widget(EditName) get]
  set FileViewName [$widget(FileViewName) get]
  if {$Autolabel != 1} {
    set Options ""
    set autolabel "noautolabel"
  } else {
    set Options "-a"
    set autolabel "autolabel"
  }
# update configuration file and close window
  updaterc
  Window destroy .config
}

proc POV {} {
# routine to call POV viewer
  global widget
  global POVpath
  global Platform
  global POVoptions
  global fileset
  set nfile [$widget(CurFile) get]
  set nfile [file rootname $nfile].pov
  set options [$widget(POVoptions) get]
  set base [file rootname $nfile]
  if {$fileset != 0} {
    switch $Platform {
      "windows" {
        set cmd "\"$POVpath\" $options $nfile"
        eval exec $cmd
      }
      default {
        set cmd "$POVpath $options $nfile ; pause"
        forknewterm "Run POV" $cmd 0 0
      }
    }
  } else { 
    Window show $widget(NotReady)
    focus -force $widget(NotReady)
  }
}

proc VRML {} {
# routine to call VRML viewer
  global widget
  global VRMLpath
  global Platform
  global fileset
  set nfile [$widget(CurFile) get]
  set nfile [file rootname $nfile].wrl
  set ndir  [$widget(CurDir) get]
  if {$fileset != 0} {
    switch $Platform {
      "windows" {
            set cmd "\"$VRMLpath\" file:$ndir/$nfile"
# execute VRML display unit
            eval exec $cmd
         }
      default {
          set cmd "$VRMLpath file:$ndir/$nfile"
# execute VRML display unit
          forknewterm "Running VRML" $cmd 0 0
      }
    }
  } else {
    Window show $widget(NotReady)
    focus -force $widget(NotReady)
  }
}

proc doAbout {} {
# display about window
  global widget
  Window show $widget(about)
  focus -force $widget(about)
}

proc doHelp {} {
# display help window
  global widget
  Window show $widget(help)
  focus -force $widget(help)
}

proc doConfigure {} {
# activate the configuration screen and load the widgets
  global DRAWxtlPath              # path for V4.x
  global DRAWxtlPath2             # path for V5.x
  global EditName
  global FileViewName
  global POVpath
  global VRMLpath
  global widget
  Window show .config
  $widget(DRAWxtlPath) delete 0 end
  $widget(POVpath) delete 0 end
  $widget(VRMLpath) delete 0 end
  $widget(EditName) delete 0 end
  $widget(FileViewName) delete 0 end
  $widget(DRAWxtlPath) insert 0 $DRAWxtlPath
  $widget(POVpath) insert 0 $POVpath
  $widget(VRMLpath) insert 0 $VRMLpath
  $widget(EditName) insert 0 $EditName
  $widget(FileViewName) insert 0 $FileViewName
}

proc doDRAWxtl {} {
# execute DRAWxtl
  global FileName
  global widget
  global fileset
  global Platform
  global DRAWxtlPath
  set nfile [$widget(CurFile) get]
  if {$fileset != 0} {
    switch $Platform {
      "windows" {
          set cmd "\"$DRAWxtlPath\" \"$nfile\""
# execute DRAWxtl
          eval exec $cmd >& [file rootname $nfile].cns
        }
      default {
          set cmd "$DRAWxtlPath $nfile >& [file rootname $nfile].cns"
          forknewterm "Running DRAWxtl" $cmd 0 0
        }
    }
  } else {
    Window show $widget(NotReady)
    focus -force $widget(NotReady)
  }
}

proc doEDIT {} {
# routine to launch an edit session of the data file
  global FileName
  global widget
  global fileset
  global Platform
  global EditName
  set nfile [$widget(CurFile) get]
  if {$fileset != 0} {
    set dir [$widget(CurDir) get]
    catch { cd $dir}
    switch $Platform {
      "windows" {
          set cmd "$EditName $nfile"
          eval exec $cmd >&
        }
      default {
          set cmd "$EditName $nfile"
          wm iconify .main
          forknewterm "Edit Data File" $cmd 0 0 
          wm deiconify .main
        }
    }
  } else { 
    Window show $widget(NotReady)
    focus -force $widget(NotReady)
  }
}

proc forknewterm {title command {background 0} {scrollbar 1}} {
# routine to launch a window in which to run an external program
  set termopts {-xrm "xterm*VT100.Translations: #override\\n <KeyPress>BackSpace: string(\\177)"}
  if $scrollbar {
      append termopts " -sb"
  } else {
      append termopts " +sb"
  }
  if $background {
      set suffix {&}
  } else {
      set suffix {}
  }
  eval exec xterm $termopts -title [list $title] -e /bin/sh -c [list $command] $suffix
}

proc loadrc {} {
;# load variables from configuration file
  global DRAWxtlPath
  global EditName
  global FileViewName
  global POVpath
  global VRMLpath
  global widget 
  global fileset
  global POVincl
  global loadonstart
  global defaultfinish
  global GUIexepath
  global autolabel
  global Autolabel
  global Options
  set chnid [open ~/.drawxtlrc r]
  gets $chnid DRAWxtlPath
  gets $chnid POVpath
  gets $chnid VRMLpath
  gets $chnid EditName
  gets $chnid FileViewName
  gets $chnid temp
  $widget(POVoptions) insert 0 $temp
  gets $chnid temp
  $widget(CurFile) insert 0 $temp
  gets $chnid temp
  $widget(CurDir) insert 0 $temp
  catch {cd $temp}
  gets $chnid POVincl
  gets $chnid loadonstart
  gets $chnid defaultfinish
  gets $chnid GUIexepath
  gets $chnid autolabel
  if {$autolabel == "autolabel" } {
    set Options "-a"
    set Autolabel 1
  } else {
    set Options ""
    set Autolabel 0
    set autolabel "noautolabel"
  }
  set fileset 1
  close $chnid
}

proc updaterc {} {
;# update configuration file from variables
  global DRAWxtlPath
  global EditName
  global FileViewName
  global POVpath
  global VRMLpath
  global widget
  global POVincl
  global loadonstart
  global defaultfinish
  global GUIexepath
  global autolabel
  global Autolabel
  global Options
  set chnid [open ~/.drawxtlrc w]    ;# open file
  puts $chnid $DRAWxtlPath
  puts $chnid $POVpath
  puts $chnid $VRMLpath
  puts $chnid $EditName
  puts $chnid $FileViewName
  set temp [$widget(POVoptions) get]
  puts $chnid $temp
  set temp [$widget(CurFile) get]
  puts $chnid $temp
  set temp [$widget(CurDir) get]
  puts $chnid $temp
  puts $chnid $POVincl
  puts $chnid $loadonstart
  puts $chnid $defaultfinish
  puts $chnid $GUIexepath
  if {$Autolabel != 1} {
    set autolabel "noautolabel"
    set Options ""
  } else {
    set autolabel "autolabel"
    set Options "-a"
  }
  puts $chnid $autolabel
  close $chnid
}

proc main {argc argv} {
  global widget
  global DRAWxtlPath
  global EditName
  global FileViewName
  global Platform
  global POVpath
  global VRMLpath
  global FileName
  global fileset
  global POVincl
  global loadonstart
  global defaultfinish
  global GUIexepath
  if {[info sharedlibextension] == ".dll"} {
            set Platform "windows"
  } else {
            set Platform "other"
  }
# check if configuration file exists
  set name [glob -nocomplain "~/.drawxtlrc"]
  if {$name == ""} {
# file does not exist - initialize configuration variables
    $widget(POVoptions) insert 0 "+W500 +H500 +D +FC +A0.3"
    set fileset 0
    $widget(CurDir) insert 0 [pwd]
    set DRAWxtlPath "DRAWxtl"
    set POVpath "x-povray"
    set VRMLpath "vrweb"
    set EditName "vi"
    set FileViewName "more"
    set POVincl ""
    set loadonstart "no"
    set defaultfinish "finish 0.00 0.00 0.00 0.00"
    set GUIexepath "DRAWxtl"
# create initialization file
    updaterc
  } else {
# file exists - load variables from file
    loadrc
  }
}

proc Window {args} {
    global vTcl
    set cmd [lindex $args 0]
    set name [lindex $args 1]
    set newname [lindex $args 2]
    set rest [lrange $args 3 end]
    if {$name == "" || $cmd == ""} {return}
    if {$newname == ""} {
        set newname $name
    }
    set exists [winfo exists $newname]
    switch $cmd {
        show {
            if {$exists == "1" && $name != "."} {wm deiconify $name; return}
            if {[info procs vTclWindow(pre)$name] != ""} {
                eval "vTclWindow(pre)$name $newname $rest"
            }
            if {[info procs vTclWindow$name] != ""} {
                eval "vTclWindow$name $newname $rest"
            }
            if {[info procs vTclWindow(post)$name] != ""} {
                eval "vTclWindow(post)$name $newname $rest"
            }
        }
        hide    { if $exists {wm withdraw $newname; return} }
        iconify { if $exists {wm iconify $newname; return} }
        destroy { if $exists {destroy $newname; return} }
    }
}

#################################
# VTCL GENERATED GUI PROCEDURES
#

proc vTclWindow. {base} {
    if {$base == ""} {
        set base .
    }
    ###################
    # CREATING WIDGETS
    ###################
    wm focusmodel $base passive
    wm geometry $base 200x200+0+0
    wm maxsize $base 804 585
    wm minsize $base 112 1
    wm overrideredirect $base 1
    wm resizable $base 1 1
    wm withdraw $base
    wm title $base "DRAWxtl Configuration"
    ###################
    # SETTING GEOMETRY
    ###################
}

proc vTclWindow.about {base} {
    if {$base == ""} {  
        set base .about
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 300x270+350+270
    wm maxsize $base 804 585
    wm minsize $base 112 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "About DRAWxtl"
    message $base.mes20  -aspect 1500 -font {{Times New Roman} 18 bold} -padx 6 -pady 3  -text {V1.1 Tcl Shell for} 
    message $base.mes21  -aspect 1500 -font {{Times New Roman} 24 {bold italic}}  -foreground #ff0000 -padx 6 -pady 3 -text {DRAWxtl V4.2} 
    message $base.mes22  -aspect 1500 -font {{Times New Roman} 18 bold} -padx 6 -pady 3  -text {Revised 26.06.05} 
    message $base.mes23  -aspect 1500 -font {{Times New Roman} 14 bold} -justify center  -padx 6 -pady 3 -text {Coded with Visual Tcl V1.10} 
    message $base.mes25  -aspect 1500 -font {{Times New Roman} 14 bold} -justify center  -padx 6 -pady 3 -text {L.W. Finger, Carnegie Institution} 
    message $base.mes26  -aspect 1500 -font {{Times New Roman} 14 bold} -justify center  -padx 6 -pady 3 -text {M. Kroeker, Darmstadt University} 
    message $base.mes26a -aspect 1500 -font {{Times New Roman} 14 bold} -justify center  -padx 6 -pady 3 -text {B. Toby, NIST} 
    message $base.mes27  -aspect 1500 -font {{Times New Roman} 14 bold} -justify center  -padx 6 -pady 3 -text {http://www.lwfinger.net/drawxtl/} 
    button $base.but24  -command {global widget
    Window hide $widget(about)
    focus -force $widget(main)}  -padx 9 -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.mes20  -x 5 -y 10 -width 290 -height 42 -anchor nw -bordermode ignore 
    place $base.mes21  -x 30 -y 55 -width 230 -height 22 -anchor nw -bordermode ignore 
    place $base.mes22  -x 30 -y 85 -width 230 -height 22 -anchor nw -bordermode ignore 
    place $base.mes23  -x 5 -y 110 -width 290 -height 22 -anchor nw -bordermode ignore 
    place $base.mes25  -x 5 -y 140 -width 290 -height 22 -anchor nw -bordermode ignore 
    place $base.mes26  -x 5 -y 160 -width 290 -height 22 -anchor nw -bordermode ignore 
    place $base.mes26a -x 5 -y 180 -width 290 -height 22 -anchor nw -bordermode ignore 
    place $base.mes27  -x 5 -y 200 -width 290 -height 22 -anchor nw -bordermode ignore 
    place $base.but24  -x 105 -y 225 -width 76 -height 31 -anchor nw -bordermode ignore
}

proc vTclWindow.config {base} {
    if {$base == ""} {
        set base .config
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
}

proc vTclWindow.help {base} {
    if {$base == ""} {
        set base .help
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "DRAWxtl Command Reference"

    frame $base.buttons
    pack  $base.buttons -side bottom -expand y -fill x -pady 2m
    button $base.buttons.dismiss -text Dismiss -command "destroy $base"
    pack $base.buttons.dismiss  -side left -expand 1

    text $base.text  -yscrollcommand "$base.scroll set" -setgrid true \
			-width 85 -height 40 -wrap word
    scrollbar $base.scroll -command "$base.text yview"
    pack $base.scroll -side right -fill y
    pack $base.text -expand yes -fill both

    $base.text tag configure margins -lmargin1 12m -lmargin2 6m -rmargin 10m
 
    $base.text insert end {
Input Instructions for DRAWxtl:

In this program, color is represented in symbolic form, and must be one of 
the color names from POV's "colors.inc" file. The color names and associated 
RGB values are listed in Table I, and sorted by RGB values in Table II. Any 
of these colors may be made transparent by appending the phrase "filter xx" 
after it, where xx is a number from 0.0 to 1.0. (The larger the value of 
xx, the more transparent will be the entity.

Each line of the input file is preceded by a character sequence that
describes the type of information, as follows:


 arrow       xp yp zp xc yc zc length diameter color

defines the position in fractional coordinates (xp, yp, zp) of the triclinic,
nuclear cell, the components (xc, yc, zc) of the spin vector, and the length
diameter and color of the arrow.. The reference direction for xc is parallel
to direct space axis a, yc is parallel (a x b) x a, and the reference direction
for zc is perpendicular to xc and yc. The only space-group symmetry elements
used in placing arrows are the translations described by the mag_trans command below.


 atom           name number x y z

defines the atoms. The 1- to 4-character name will be used on the commands 
that describe the objects to be created, the number is to identify which 
atom of this type, and x y z are the fractional coordinates in the unit cell.
If the position is more easily represented as a fraction such as 1/3, 1/4, 5/6,
etc., it may be given in this form.

 axislines	width color

defines the width and color of the lines that depict the principal axes of
ellipsoids. The color defaults to dark gray (Gray20). If this is not given,
any ellipsoids will be drawn with principal axes of 0.00015 times the overall
scale factor, which should normally be appropriate.


 background      color

sets the color of the background of the graphical views. The default color is white.


 betaij         name number color

defines the anisotropic thermal coefficients for an atom and color of the 
ellipsoid. The name and number should correspond to the atom input described 
above. In the POV version of the program, the principal ellipses are drawn 
in black. The ellipses will, of course, be invisible if the ellipsoid is also 
black.


 bij or Bij     name color
                                                  
defines the anisotropic thermal coefficients for an atom and the color of the 
ellipsoid to be drawn. The name and number should correspond to the atom input 
described above.


 bond           name1 name2 radius min max color

where name1 and name2 indicate the types of atoms to be connected by a bond, 
radius is the radius of the resulting cylinder, and the minimum and maximum 
lengths are given in the same units as the unit cell.


 bounds         xlim ylim zlim  

defines X-, Y- and Z-limits of the view box in Angstrom (defaults to
-10..10 Angstrom around the center). This information may also be given 
with the -b command-line switch.


 box            radius color

defines the radius and color of the cylinders that form the unit cell boundary.
If radius is 0.0, plotting of the unit cell is suppressed. The radius of the 
cylinders will be scaled with the size of the drawing. The default size is 0.02.


 cell           a b c alpha beta gamma

unit-cell lengths and angles. If no angles are listed, they are assumed
to be the fixed values for the symmetry class.


 clip          xmin xmax ymin ymax zmin zmax

defines a-,b-,c- clipping range in fractions of the axes. Any bonds extending 
beyond these limits will be cut off at half-length. This command is to be used 
in conjunction with the pack keyword to produce 'dangling' bonds in the display 
of framework structures.


 cutout         color     (used only for POV or openGL)     

sets the POV generation of thermal ellipsoids to have one octant removed, as 
in the program ORTEP.  If this command is not given, all ellipsoids will be 
complete. The color is for the planes that describe the edges of the cutout. 


 dash           name1 name2 radius min max color

where name1 and name2 indicate the types of atoms to be connected by a dashed
bond, radius is the radius of the resulting cylinder, and the minimum and
maximum lengths are given in the same units as the unit cell.


 depthcue       depth (POV only)

defines the extent to which the size of polyhedral edges is increased as the 
edge is closer to the viewer.



 edges          radius color

defines the thickness and color of cylinders along the edges of polyhedra 
that may be used to emphasize the faces. The radius of these cylinders will 
also be scaled with the size of the drawing.  By default, black edges of size 
0.02 will be drawn.


 ellipcolor     name number color

defines the color for ellipsoids when the thermal ellipsoid information has 
been read from a CIF, GSAS, SCHAKAL or SHELX import or inline file. The name 
and number must match the identification information in the input file. The 
parameter number may be an asterisk (*) to indicate all atoms with that name. 
In addition, these input lines must be after the import or inline command.


 ellipsoids     probability

sets the size of the ellipsoid such that that fraction of the electron
density is contained within the bounding surface. Use either 0.50 or 50 to 
get the standard (default) 50% ellipsoids.


 finish        ambient diffuse specular roughness

defines parameters for the POV lighting functions that are applied to
all surfaces. Suggested values are 0.7 0.3 0.08 0.01 to reduce the harsh
contrasts that can result from the default material properties in POV.


 frame        comment

similar to 'end', marks the division between two complete sets of inpu
that are to be superimposed in a single output file. Use this where you
would otherwise have to create separate datafiles (e.g. one showing polyhedra,
the other selected bonds) and join the resulting POV or VRML files. For V4.1
and later, each frame may have different space groups, pack range, and object
descriptions. With this functionality, a single drawing can represent a
cage-compound framework with an adsorbed molecule that has lower symmetry than the
framework. Another option is to draw ball-and-stick and polyhedral pictures in
side-by-side unit cells.


 import         cif filename
 import         csd filename (or fdat filename)  causes the program to read
 import         gsas filename phasenumber        information from an external file.
 import         schakal filename                 'filename' is the name of the file.
 import         shelx filename
 import         wien2k filename

Import filters have been written for the CIF, FDAT (Cambridge Structure
Database=CSD), GSAS, SCHAKAL, SHELX and WIEN2k formats.  For GSAS format,
the number of the phase should also be given. From these files, the atomic
coordinates, thermal parameters, unit cell, and space group will be read.
To turn on ellipsoid output, and to set colors for the ellipsoids, use the
ellipcolor command.


 inline          cif
 inline          csd (or fdat)
 inline          schakal
 inline          shelx
 inline          wien2k

is similar to import, except that the foreign input information is included
in the DRAWxtl input file in the lines immediately following this command.
This form presently works for CIF, FDAT, CIF, SCHAKAL, SHELX and WIEN2k data.
To turn on ellipsoid output, and to set colors for the ellipsoids, use the
ellipcolor command.


 labelsize size

changes the relative size of 'labeltext' entries. The default is 1.0.


 labeltext x y z text

places the text at position x,y,z


 list maxdist

causes the program to list bond distances up to maxdist in the preliminary 
scan. If this command is not given, maxdist defaults to 3.5 Angstrom.


 lonepair       name number distance radius1 radius2 color

creates the specified number (either 1 or 2) of cones representing free 
electron pairs extending from atom name, where distance is the length of 
the cone, radius1 is the size of the tip, and radius2 is the size of the 
spherical end cap.


 lookat         u1 u2 u3 v1 v2 v3

causes the program to select an orientation such that vector u is towards the 
viewer, and the projection of vector v is vertical. This command overrides any 
view command, or the -v switch on the command line.


 mag_trans      Aa Ab Ac Ba Bb Bc Ca Cb Cc

describes the relationship between the magnetic and nuclear unit cells.
In this notation, the upper-case letter states which of the magnetic axes
is being described, and the lower-case letter corresponds to the nuclear
cell axis. This matrix defaults to the identity, which is correct if the
magnetic and nuclear cells are the same.


 magnification  factor

sets the factor to modify the overall scaling is case the automatic value is 
not correct. This command matches the -m command line switch.


 mapcalclimits xmin xmax ymin ymax zmin zmax

describes the region of direct space (in fractional coordinates) for which
the map has been calculated. Map types that are self documenting such as
FullProf and JANA2000 do not need this line. For other types, 0 to 1 in
all three directions will be assumed.


 mapcontour level style color

defines a new contour at 'level'. The style can be either 'mesh' or 'solid',
and the color is set by 'color'


 mapread  maptype filename calctype

reads a Fourier map of type 'maptype' from the file named 'filename'. At
present, GSAS-style (maptype = grd), JANA2000-style (maptype = stf), WIEN2k
(maptype = w2k), VASP (maptype = vsp), and FullProf (maptype = flp) maps are
read. If a Shelx/Cif-style Fo/Fc file (maptype = fcf) is given, the electron
density is calculated during the initial read, which may take a few minutes.
Both A/B and Fo/phi data formats (Shelx commands LIST 3 and LIST 6) are
supported. The calctype may be 'Fo', 'Fc', 'Fo-Fc', or '2Fo-Fc' to indicate
the type of map to calculate. If this parameter is not given, an 'Fo' map is
calculated.


 mapregion xmin xmax ymin ymax zmin zmax

describes the region of direct space (in fractional coordinates) that the map
is to be displayed in the output. If not entered, these values default to the
values given under 'mapcalclimits'.


 molcomp        dist

causes any incomplete molecules in the display box to be completed. The value 
of dist defines the maximum intramolecular distance. Caution: If this distance 
is greater than any intermolecular distance, or if the material is not 
molecular, the display list will overflow.


 nolabels

removes all axis labels from the output diagrams.


 noshadow

causes objects in the POV file not to cast shadows.


 origin         xcenter ycenter zcenter

defines center of view box in crystal coordinates (defaults to
0.5 0.5 0.5). This command is the same as the -o command-line switch.


 orthographic                                      (VRML version only)

causes the camera to be changed from the normal perspective view to an 
orthographic view.


 pack           xmin xmax ymin ymax zmin zmax

defines a-,b-,c- plotting range in fractions of the axes, similar to the 
PLUTO (Motherwell & Clegg 1978)) PACK RANGE command (this is especially 
useful for highly oblique cells, where the orthorhombic view box does not 
always give satisfactory results).  This command is the same as the -p 
command-line switch.


 phong          value size                (used only for POV)

defines the amount of Phong highlighting on spheres and ellipsoids.  The 
value ranges between 0.0 and 1.0, where 0.0 gives no highlight, and 1.0 
causes complete saturation at the center of the highlight. The size ranges 
from 1.0 (very dull) to 250 highly) polished). The default quantities are 
0.1 and 1.0, which gives a large, dull highlight.  If value is 0.0, the 
image can be rendered much more quickly.


 plane          name length color

defines the center of a plane group, such as CO3 that is to be drawn in a 
structure, where name is the name of the atom at the center and length is 
the maximum distance to coordinating anions. No atoms that are mentioned in 
polysz commands will be considered as the corners of a plane.


 polyedge name radius color
    
defines the thickness and color of cylinders used to emphasize the faces 
along the edges of polyhedra for atom 'name'. The radius of these cylinders 
will also be scaled with the size of the drawing.


 polysz         name length color                 

defines a polyhedron, where name is the name of an atom at the center of a 
polyhedron and length is the maximum length of distances to atoms that are 
to be considered as the vertices of the polyhedron. No atoms that are 
mentioned in polysz or plane commands will be considered as the vertices of 
a polyhedron.  The polyhedra can be of any desired complexity. For polyhedra
with both upper and lower limits (which might be desirable for intermetallic
compounds), use the 'shell' command.


 polytolerance      factor
 polylimit          factor
 polyfudge          factor

modifies the internal limit for the deviation of vertices from the common 
plane. While the default value (0.1) will always generate correct drawings, 
it may sometimes be desirable to increase it to create idealized views of 
nearly symmetrical polyhedra that would otherwise show creased surfaces.


 polyvert name1 name2 length color

defines polyhedra in the manner of the polysz command, except that the 
polyhedron around the name1 atom will only include anions of type name2.


 rem            text                              
 REM            text                              

Any line preceded by this command is ignored.


 shell         name length1 length2 color                 

defines a polyhedral hull, where name is the name of an atom at the center of a 
polyhedron and length1 and length2 are the mimimum and maximum lengths of 
distances to atoms that are to be considered as the vertices of the 
polyhedron. No atoms that are mentioned in polysz or plane commands will be 
considered as the vertices of a polyhedron.  The polyhedra can be of any 
desired complexity, and can be stacked as desired. 


 slab a b c alpha beta gamma xoff yoff zoff xrot yrot zrot flag

defines a (possibly oblique) cutout box of the specified axis lengths and
angles that is offset by xoff,yoff zoff from the origin of the structure
and rotated at angles xrot yrot zrot relative to it. If flag is set to 1,
any part of the structure outside the box is deleted. If flag is 2, the
outline of the box is overlaid on the unchanged image to allow accurate
placement of the cutout box. 


 spgp    symbol
 spgr    symbol
 sgrp    symbol       

Space Group name consisting of the Bravais lattice symbol (must be upper 
case) followed by a space, the elements parallel to the first axis followed 
by a space, etc. Examples are I 41/a m d, P 21/n, I a 3 d, P b n m, etc. The 
generators will always select the origin choice with a center of symmetry at 
the origin. Furthermore, all monoclinic cells will have the unique axis 
parallel to the b axis, unless the full symbol is used, i.e. P 1 1 21/n 
describes a monoclinic cell with c as the unique axis.  
N.B.: Rhombohedral space groups must be represented in the hexagonal form.

                                                  
 sphere         name radius color
 sphere         name number radius color

where name is a one- or two-character symbol of the atom type, radius is the
radius of the sphere in Angstrom, and color is the color of the sphere to be
drawn. If the first form is used, all atoms with that name will be drawn.
The second restricts the command to that name and number only


 title, titl    text

General description of the structure - this line may appear anywhere in the 
file, but is generally first.


 uij, Uij       name number u color

defines the anisotropic thermal coefficients for an atom and color of the 
ellipsoid. The name and number should correspond to the atom input described 
above.


 vectors     posx  posy  posz

turns on the orientation vector triple at a corner of the diagram. The optional
parameters pos[xyz] specify the location of the origin. If not given, the program
will guess at a location


 view           xrot yrot zrot

where xrot, yrot and zrot are view rotation angles in Cartesian space. These 
values correspond to a rotation of xrot about the x axis, followed by a 
rotation of yrot about the (new) y axis, and, a rotation of zrot about the 
(new) z axis.


 vrml1  (used only for VRML)

causes the output VRML file to have the older, VRML1 syntax for compatibility 
with some older viewers that are not VRML97 compliant.


 vrml2 or vrml97 (used only for VRML)

These commands do nothing, but are kept for compatibility with old data files. 
VRML97 format is now the default. A description of some of the VRML97 features is 
given in Appendix B. Do NOT use this form unless your VRML viewer is VMRL97 compliant!


 xyzoff         u1  u2 u3

causes all atom coordinates to be shifted by -u.  This command is used 
whenever the origin defined for a structure does not conform to the standard 
origin selected by the space-group generator.


 end
 END

The last line of a file that is read. Any information past this point will 
be ignored.

Command Line Switches:

Although control information is usually entered via the input file, it is
also possible to override the file via command line switches as follows:

                                    defines X-, Y- and Z-limits of the view
 -b  xlim ylim zlim                 box in angstroms (defaults to -10..10
                                    Angstrom around center)

                                    expands the VRML output by adding
 -c                                 comments. This option should not be
                                    used for any VRML files placed in a Web
                                    site.

                                    places three orthographic and three
                                    perspective cameras (viewpoints) along
                                    the crystallographic axes in the VRML
                                    output. The default is a single
                                    perspective camera. Select this
                                    multiple-camera option with caution, as
                                    not all VRML viewers support it. At
 -C                                 this writing, the Live3D viewer in
                                    Netscape fails with multi-camera
                                    drawings, and the current version of
                                    VRweb for Windows displays the drawing
                                    correctly, but the center of rotation
                                    is incorrectly placed. The final Unix
                                    version (1.5) of VRWeb is known to work
                                    correctly.

 -G                                 suppresses the openGL view.

 -h
 -?                                 displays usage information

 -H                                 suppresses the help information on the
                                    openGL screen.


                                    changes the magnification factor for
 -m  factor                         POV and VRML diagrams in case the
                                    initial size is not correct (defaults
                                    to 1.0)

 -n                                 suppresses plotting of unit cell box

 -o  xcenter ycenter zcenter        defines center of view box in crystal
                                    coordinates (defaults to 0.5 0.5 0.5)

                                    defines a-,b-,c- plotting range in
                                    fractions of the axes, similar to the
                                    PLUTO (Motherwell & Clegg 1978) PACK
 -p  ymin xmax ymin ymax zmin zmax  RANGE command (this is especially
                                    useful for hexagonal cells, where the
                                    orthorhombic view box does not always
                                    give satisfactory results)

                                    defines view rotation angles around the
 -v  xangle yangle zangle           axes of the Cartesian view coordinate
                                    system (equivalent to the view keyword)
                                    (defaults to 0 0 0)

                                    display a orientation vector triple at
 -u                                 the edge of the diagram. If this switch
                                    is not used, the axes are labeled.


Sample input file

title
Buckyball with balls and sticks
cell 14.16 14.16  14.16
pack -.3 .3 -.3 .3 -.3 .3
spgp F m 3
sphere c 0.4 Red filter 0.3
bond c c 0.1 1.2 1.5 Gray30
atom c 1 0.04908 0.00000 0.24510
atom c 2 0.10028 0.08284 0.21346
atom c 3 0.18313 0.05120 0.16226
origin 0 0 0
magnification 0.7
view -18 0 0
end
} 
#    button $base.but94  -command {global widget
#    Window hide $widget(help)
#    focus -force $widget(main)}  -padx 9 -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
#    place $base.mes99  -x 5 -y 5 -width 400 -height 300 -anchor nw -bordermode ignore 
#    place $base.but94  -x 205 -y 285 -width 76 -height 31 -anchor nw -bordermode ignore
}

proc vTclWindow.config {base} {
    if {$base == ""} {
        set base .config
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }


    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 500x250+250+250
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm deiconify $base
    wm title $base "DRAWxtl Configuration"
    button $base.but25  -command OKConfigure -padx 9 -pady 3 -text OK 
    button $base.but26  -command CancelConfigure -padx 9 -pady 3 -text Cancel 
    entry $base.ent27  -foreground #fe0000 
    label $base.lab28  -anchor w -borderwidth 1 -foreground #000000  -text {DRAWxtl Path or Command} 
    button $base.but28a -command FileBrowse1 -padx 6 -pady 3 -text Browse 
    button $base.but29a -command FileBrowse2 -padx 6 -pady 3 -text Browse 
    button $base.but30a -command FileBrowse3 -padx 6 -pady 3 -text Browse 
    label $base.lab29  -anchor w -borderwidth 1 -foreground #000000  -text {VRML Path or Command} 
    entry $base.ent30  -foreground #fe0000 
    label $base.lab33  -anchor w -borderwidth 1 -text {POV Path or Command} 
    entry $base.ent34  -foreground #fe0000 
    entry $base.ent36  -foreground #fe0000 
    label $base.lab37  -anchor w -borderwidth 1 -text {Name of Editor} 
    label $base.lab38  -anchor w -borderwidth 1 -text {Name of File Viewer} 
    checkbutton $base.cb1 -text {Autolabel SHELX Input} -variable Autolabel
    entry $base.ent39  -foreground #fe0000 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.but25   -x 420 -y 20  -width 60  -height 26 -anchor nw -bordermode ignore 
    place $base.but26   -x 420 -y 55  -width 60  -height 26 -anchor nw -bordermode ignore 
    place $base.ent27   -x 20  -y 30  -width 330 -height 22 -anchor nw -bordermode ignore 
    place $base.ent30   -x 20  -y 80  -width 330 -height 22 -anchor nw -bordermode ignore 
    place $base.ent34   -x 20  -y 130 -width 330 -height 22 -anchor nw -bordermode ignore 
    place $base.but28a  -x 360 -y 30  -width 55  -height 22 -anchor nw -bordermode ignore 
    place $base.but29a  -x 360 -y 80  -width 55  -height 22 -anchor nw -bordermode ignore 
    place $base.but30a  -x 360 -y 130 -width 55  -height 22 -anchor nw -bordermode ignore 
    place $base.lab28  -x 20 -y 10 -width 251 -height 18 -anchor nw -bordermode ignore 
    place $base.lab29  -x 20 -y 60 -width 251 -height 18 -anchor nw -bordermode ignore 
    place $base.lab33  -x 20 -y 110 -width 251 -height 18 -anchor nw -bordermode ignore 
    place $base.ent36  -x 20 -y 185 -anchor nw -bordermode ignore 
    place $base.lab37  -x 20 -y 165 -width 136 -height 18 -anchor nw -bordermode ignore 
    place $base.lab38  -x 210 -y 165 -width 136 -height 18 -anchor nw -bordermode ignore 
    place $base.ent39  -x 210 -y 185 -anchor nw -bordermode ignore
    place $base.cb1    -x 20 -y 215 -anchor nw -bordermode ignore
}

proc vTclWindow.main {base} {
    if {$base == ""} {
        set base .main
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel \
        -highlightbackground #ff0000 -highlightcolor #ffffff -menu .main.m27 \
        -relief raised 
    wm focusmodel $base passive
    wm geometry $base 541x400+205+222
    wm maxsize $base 804 625
    wm minsize $base 112 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm deiconify $base
    wm title $base "DRAWxtl Control"
    menu $base.#top25#m27 \
        -cursor {} -type menubar 
## Menu items here
    menubutton $base.men01 \
        -background #c4c4c4 -menu .main.men01.m  -pady 3 -relief raised \
        -text File 
    menu $base.men01.m -tearoff 0
    $base.men01.m add command -command FileGet -label {Select Data File} 
    $base.men01.m add command -command doConfigure -label Configure 
    $base.men01.m add  command -command {updaterc; exit}  -label Exit
    button $base.men02 \
        -background #c4c4c4 -command doEDIT -height 20 -pady 3 \
        -relief raised -text {Edit Data} 
    button $base.men03 \
        -background #c4c4c4 -command doDRAWxtl -padx 9 -pady 3 -relief raised \
        -text {Run DRAWxtl} 
    menubutton $base.men04 \
        -background #c4c4c4 -menu .main.men04.m -padx 7 -pady 5 -text View -relief raised 
    menu $base.men04.m \
        -tearoff 0 
    $base.men04.m add command \
        -command VRML -label VRML 
    $base.men04.m add command \
        -command POV -label POV 
    $base.men04.m add command \
        -command Listing -label Listing 
    menubutton $base.men05 \
        -background #c4c4c4 -menu .main.men05.m -padx 9 -pady 3 -relief raised \
        -text Help
    menu $base.men05.m -tearoff 0
    $base.men05.m add  command -command doAbout -label "About DRAWxtl"
    $base.men05.m add  command -command doHelp -label "Command Reference"
    button $base.men06 \
        -background #c4c4c4 -command {updaterc; exit} -padx 9 -pady 3 -relief raised \
        -text Exit 

# message items

    message $base.mes17 \
        -aspect 1500 -font {{new century schoolbook} 12 {}} -padx 6 -pady 3 \
        -text {Current Directory:} 
    message $base.mes18 \
        -aspect 1500 -font {{new century schoolbook} 12 {}} -padx 6 -pady 3 \
        -text {Current Str. File:} 
    message $base.mes19 \
        -aspect 1500 -font {{new century schoolbook} 12 {}} -justify center \
        -padx 6 -pady 3 -text {Command Options:} 
    message $base.mes33 \
        -aspect 1500 -font {{new century schoolbook} 72 bold} \
        -foreground #fc0000 -padx 6 -pady 3 -text "DRAWxtl V4.2" 
    message $base.mes34 \
        -aspect 1500 -font {{new century schoolbook} 20 bold} \
        -foreground #0044fe -padx 6 -pady 3 \
        -text {Crystal Structure Drawing Program} 
    message $base.mes35 \
        -aspect 1500 -font {{new century schoolbook} 20 italic} \
        -foreground #0044fe -highlightcolor #000606 -padx 6 -pady 3 \
        -text {L. Finger, M. Kroeker and B. Toby} 
    entry $base.ent17 \
        -font {{new century schoolbook} 12 bold} -foreground #f60000 \
        -textvariable Options 
    entry $base.ent18 \
        -font {{new century schoolbook} 12 bold} -foreground #f60000 \
        -textvariable POVOptions 
    entry $base.ent20 \
        -font {{new century schoolbook} 12 bold} -foreground #ff0000 
    entry $base.ent21 \
        -font {{new century schoolbook} 12 bold} -foreground #ff0000 
    message $base.mes20 \
        -aspect 1500 -font {{new century schoolbook} 12 {}} -padx 5 -pady 2 \
        -text {POV Options:} 
    ###################
    # SETTING GEOMETRY
    ###################

    place $base.men01 -x 5 -y 5 -width 35 -height 20 -anchor nw -bordermode ignore 
    place $base.men02 -x 40 -y 5 -width 66 -height 21 -anchor nw -bordermode ignore 
    place $base.men03 -x 100 -y 5 -height 21 -anchor nw -bordermode ignore 
    place $base.men04 -x 200 -y 5 -height 20 -anchor nw -bordermode ignore 
    place $base.men05 -x 240 -y 5 -width 50 -height 20 -anchor nw -bordermode ignore 
    place $base.men06 -x 485 -y 5 -width 50 -height 20 -anchor nw -bordermode ignore 

    place $base.mes17 -x 45 -y 235 -width 144 -height 26 -anchor nw -bordermode ignore 
    place $base.mes18 -x 45 -y 270 -width 127 -height 26 -anchor nw -bordermode ignore 
    place $base.mes19 -x 45 -y 305 -width 138 -height 26 -anchor nw -bordermode ignore 
    place $base.mes20 -x 45 -y 345 -width 96 -height 24 -anchor nw -bordermode ignore 
    place $base.mes33 -x -5 -y 40 -width 550 -height 77 -anchor nw -bordermode ignore 
    place $base.mes34 -x 5 -y 135 -width 548 -height 42 -anchor nw -bordermode ignore 
    place $base.mes35 -x 0 -y 180 -width 550 -height 42 -anchor nw -bordermode ignore 
    place $base.ent17 -x 195 -y 310 -width 306 -height 22 -anchor nw -bordermode ignore 
    place $base.ent18 -x 195 -y 345 -width 306 -height 22 -anchor nw -bordermode ignore 
    place $base.ent20 -x 195 -y 240 -width 306 -height 22 -anchor nw -bordermode ignore 
    place $base.ent21 -x 195 -y 275 -width 306 -height 22 -anchor nw -bordermode ignore 
}

proc vTclWindow.notready {base} {
    if {$base == ""} {
        set base .notready
    }
    if {[winfo exists $base]} {
        wm deiconify $base; return
    }
    ###################
    # CREATING WIDGETS
    ###################
    toplevel $base -class Toplevel
    wm focusmodel $base passive
    wm geometry $base 201x157+250+250
    wm maxsize $base 1009 738
    wm minsize $base 1 1
    wm overrideredirect $base 0
    wm resizable $base 0 0
    wm title $base "Data File Not Ready"
    label $base.lab18  -borderwidth 1 -font {Helvetica 24 bold} -foreground #fe0000  -text {Data File} 
    label $base.lab19  -borderwidth 1 -font {Helvetica 24 bold} -foreground #fe0000  -text {Not Selected} 
    button $base.but20  -command {Window hide .notready } -padx 9 -pady 3 -text OK 
    ###################
    # SETTING GEOMETRY
    ###################
    place $base.lab18  -x 5 -y 25 -width 186 -height 28 -anchor nw -bordermode ignore 
    place $base.lab19  -x 5 -y 55 -width 191 -height 38 -anchor nw -bordermode ignore 
    place $base.but20  -x 75 -y 110 -anchor nw -bordermode ignore
}

Window show .
Window show .main

main $argc $argv

